from abc import ABC, abstractmethod

from bot_data.model.technician_config import TechnicianConfig
from bot_data.model.technician_id_config import TechnicianIdConfig
from bot_data.model.technician_ping_url_config import TechnicianPingUrlConfig


class TechnicianConfigRepositoryABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def does_technician_config_exists(self) -> bool:
        pass

    @abstractmethod
    def get_technician_config(self) -> TechnicianConfig:
        pass

    @abstractmethod
    def add_technician_config(self, technician_config: TechnicianConfig):
        pass

    @abstractmethod
    def update_technician_config(self, technician_config: TechnicianConfig):
        pass

    @abstractmethod
    def delete_technician_config(self, technician_config: TechnicianConfig):
        pass

    @abstractmethod
    def add_technician_id_config(self, technician_id: TechnicianIdConfig):
        pass

    @abstractmethod
    def update_technician_id_config(self, technician_id: TechnicianIdConfig):
        pass

    @abstractmethod
    def delete_technician_id_config(self, technician_id: TechnicianIdConfig):
        pass

    @abstractmethod
    def add_technician_ping_url_config(self, technician_ping_url: TechnicianPingUrlConfig):
        pass

    @abstractmethod
    def update_technician_ping_url_config(self, technician_ping_url: TechnicianPingUrlConfig):
        pass

    @abstractmethod
    def delete_technician_ping_url_config(self, technician_ping_url: TechnicianPingUrlConfig):
        pass
