ALTER TABLE `GameServers`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `GameServers`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `GameServersHistory`
(
    `Id`       BIGINT(20)   NOT NULL,
    `Name`     VARCHAR(255) NOT NULL,
    `ServerId` BIGINT(20)   NOT NULL,
    `ApiKeyId` BIGINT(20)   NOT NULL,
    `Deleted`  BOOL DEFAULT FALSE,
    `DateFrom` DATETIME(6)  NOT NULL,
    `DateTo`   DATETIME(6)  NOT NULL
);

DROP TRIGGER IF EXISTS `TR_GameServersUpdate`;

CREATE TRIGGER `TR_GameServersUpdate`
    AFTER UPDATE
    ON `GameServers`
    FOR EACH ROW
BEGIN
    INSERT INTO `GameServersHistory` (
        `Id`, `Name`, `ServerId`, `ApiKeyId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.Name, OLD.ServerId, OLD.ApiKeyId, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_GameServersDelete`;

CREATE TRIGGER `TR_GameServersDelete`
    AFTER DELETE
    ON `GameServers`
    FOR EACH ROW
BEGIN
    INSERT INTO `GameServersHistory` (
        `Id`, `Name`, `ServerId`, `ApiKeyId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.Name, OLD.ServerId, OLD.ApiKeyId, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;