from cpl_discord.service import DiscordBotServiceABC
from cpl_query.extension import List

from bot_graphql.abc.query_abc import QueryABC


class DiscordQuery(QueryABC):
    def __init__(
        self,
        bot: DiscordBotServiceABC,
    ):
        QueryABC.__init__(self, "Discord")

        self._bot = bot

        self.set_field("guilds", self._resolve_guilds)
        self.set_field("users", self._resolve_users)

    def _resolve_guilds(self, *_, filter=None):
        guilds = self._bot.guilds

        if filter is None:
            return guilds

        if "id" in filter:
            guilds = self._bot.guilds.where(lambda g: g.id == int(filter["id"]))

        if "name" in filter:
            guilds = self._bot.guilds.where(lambda g: g.name == filter["name"])

        return guilds

    def _resolve_users(self, *_, filter=None):
        users = List(any).extend(self._bot.users)

        if filter is None:
            return users

        if "id" in filter:
            users = users.where(lambda g: g.id == int(filter["id"]))

        if "name" in filter:
            users = users.where(lambda g: g.name == filter["name"])

        if "bot" in filter:
            users = users.where(lambda g: g.bot == bool(filter["bot"]))

        return users
