from cpl_core.database.context import DatabaseContextABC
from cpl_discord.service import DiscordBotServiceABC

from bot_data.model.user_joined_voice_channel import UserJoinedVoiceChannel
from bot_data.model.user_joined_voice_channel_history import UserJoinedVoiceChannelHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class UserJoinedVoiceChannelQuery(DataQueryWithHistoryABC):
    def __init__(self, bot: DiscordBotServiceABC, db: DatabaseContextABC):
        DataQueryWithHistoryABC.__init__(
            self, "UserJoinedVoiceChannel", "UserJoinedVoiceChannelsHistory", UserJoinedVoiceChannelHistory, db
        )

        self._bot = bot

        self.set_field("id", self.resolve_id)
        self.set_field("channelId", self.resolve_channel_id)
        self.set_field("channelName", self.resolve_channel_name)
        self.set_field("user", self.resolve_user)
        self.set_field("time", self.resolve_time)
        self.set_field("joinedOn", self.resolve_joined_on)
        self.set_field("leavedOn", self.resolve_leaved_on)

    @staticmethod
    def resolve_id(x: UserJoinedVoiceChannel, *_):
        return x.id

    @staticmethod
    def resolve_channel_id(x: UserJoinedVoiceChannel, *_):
        return x.channel_id

    @staticmethod
    def resolve_channel_name(x: UserJoinedVoiceChannel, *_):
        return x.channel_name

    @staticmethod
    def resolve_user(x: UserJoinedVoiceChannel, *_):
        return x.user

    @staticmethod
    def resolve_time(x: UserJoinedVoiceChannel, *_):
        return x.time

    @staticmethod
    def resolve_joined_on(x: UserJoinedVoiceChannel, *_):
        return x.joined_on

    @staticmethod
    def resolve_leaved_on(x: UserJoinedVoiceChannel, *_):
        return x.leaved_on
