import os

from ariadne import make_executable_schema, load_schema_from_path
from graphql import GraphQLSchema

from bot_graphql.abc.query_abc import QueryABC
from bot_graphql.mutation import Mutation
from bot_graphql.query import Query


class Schema:
    def __init__(self, query: Query, mutation: Mutation, queries: list[QueryABC]):
        type_defs = load_schema_from_path(os.path.join(os.path.dirname(os.path.realpath(__file__)), "graphql/"))
        self._schema = make_executable_schema(type_defs, query, mutation, *queries)

    @property
    def schema(self) -> GraphQLSchema:
        return self._schema
